org.activiti.engine.task

## Interface TaskInfoQuery<T extends TaskInfoQuery<?,?>,V extends TaskInfo>

- All Superinterfaces:
    Query<T,V>
  All Known Subinterfaces:
    HistoricTaskInstanceQuery, TaskQuery

      public interface TaskInfoQuery<T extends TaskInfoQuery<?,?>,V extends TaskInfo>
      extends Query<T,V>

  Interface containing shared methods between the `TaskQuery` and the `HistoricTaskInstanceQuery`.
  Author:
    Joram Barrez

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `deploymentId(String deploymentId)` Only select tasks which are part of a process instance which has the given deployment id.
    `T` | `deploymentIdIn(List<String> deploymentIds)` Only select tasks which are part of a process instance which has the given deployment id.
    `T` | `dueAfter(Date dueDate)` Deprecated.
    `T` | `dueBefore(Date dueDate)` Deprecated.
    `T` | `dueDate(Date dueDate)` Deprecated.
    `T` | `endOr()`
    `T` | `executionId(String executionId)` Only select tasks for the given execution.
    `T` | `includeProcessVariables()` Include global task variables in the task query result
    `T` | `includeTaskLocalVariables()` Include local task variables in the task query result
    `T` | `limitTaskVariables(Integer taskVariablesLimit)` Limit task variables
    `T` | `locale(String locale)` Localize task name and description to specified locale.
    `T` | `or()` All query clauses called will be added to a single or-statement.
    `T` | `orderByDueDateNullsFirst()` Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByDueDateNullsLast()` Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByExecutionId()` Order by execution id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByProcessDefinitionId()` Order by process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByProcessInstanceId()` Order by process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskAssignee()` Order by assignee (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskCreateTime()` Order by the time on which the tasks were created (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskDefinitionKey()` Order by task definition key (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskDescription()` Order by description (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskDueDate()` Order by task due date (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskId()` Order by task id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskName()` Order by task name (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskOwner()` Order by task owner (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTaskPriority()` Order by priority (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `orderByTenantId()` Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `T` | `processCategoryIn(List<String> processCategoryInList)` Only select tasks which are part of a process instance whose definition belongs to the category which is present in the given list.
    `T` | `processCategoryNotIn(List<String> processCategoryNotInList)` Only select tasks which are part of a process instance whose definition does not belong to the category which is present in the given list.
    `T` | `processDefinitionId(String processDefinitionId)` Only select tasks which are part of a process instance which has the given process definition id.
    `T` | `processDefinitionKey(String processDefinitionKey)` Only select tasks which are part of a process instance which has the given process definition key.
    `T` | `processDefinitionKeyIn(List<String> processDefinitionKeys)` Only select tasks that have a process definition for which the key is present in the given list
    `T` | `processDefinitionKeyLike(String processDefinitionKeyLike)` Only select tasks which are part of a process instance which has a process definition key like the given value.
    `T` | `processDefinitionKeyLikeIgnoreCase(String processDefinitionKeyLikeIgnoreCase)` Only select tasks which are part of a process instance which has a process definition key like the given value.
    `T` | `processDefinitionName(String processDefinitionName)` Only select tasks which are part of a process instance which has the given process definition name.
    `T` | `processDefinitionNameLike(String processDefinitionNameLike)` Only select tasks which are part of a process instance which has a process definition name like the given value.
    `T` | `processInstanceBusinessKey(String processInstanceBusinessKey)` Only select tasks foe the given business key
    `T` | `processInstanceBusinessKeyLike(String processInstanceBusinessKeyLike)` Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%activiti%").
    `T` | `processInstanceBusinessKeyLikeIgnoreCase(String processInstanceBusinessKeyLikeIgnoreCase)` Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%activiti%").
    `T` | `processInstanceId(String processInstanceId)` Only select tasks for the given process instance id.
    `T` | `processInstanceIdIn(List<String> processInstanceIds)` Only select tasks for the given process ids.
    `T` | `processVariableValueEquals(Object variableValue)` Only select tasks which are part of a process that has at least one variable with the given value.
    `T` | `processVariableValueEquals(String variableName, Object variableValue)` Only select tasks which are part of a process that has a variable with the given name set to the given value.
    `T` | `processVariableValueEqualsIgnoreCase(String name, String value)` Only select tasks which are part of a process that has a local string variable which is not the given value, case insensitive.
    `T` | `processVariableValueGreaterThan(String name, Object value)` Only select tasks which have a global variable value greater than the passed value when they ended.
    `T` | `processVariableValueGreaterThanOrEqual(String name, Object value)` Only select tasks which have a global variable value greater than or equal to the passed value when they ended.
    `T` | `processVariableValueLessThan(String name, Object value)` Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    `T` | `processVariableValueLessThanOrEqual(String name, Object value)` Only select tasks which have a global variable value less than or equal to the passed value when they ended.
    `T` | `processVariableValueLike(String name, String value)` Only select tasks which have a global variable value like the given value when they ended.
    `T` | `processVariableValueLikeIgnoreCase(String name, String value)` Only select tasks which have a global variable value like the given value (case insensitive) when they ended.
    `T` | `processVariableValueNotEquals(String variableName, Object variableValue)` Only select tasks which have a variable with the given name, but with a different value than the passed value.
    `T` | `processVariableValueNotEqualsIgnoreCase(String name, String value)` Only select tasks which are part of a process that has a string variable with the given value, case insensitive.
    `T` | `taskAssignee(String assignee)` Only select tasks which are assigned to the given user.
    `T` | `taskAssigneeLike(String assigneeLike)` Only select tasks which were last assigned to an assignee like the given value.
    `T` | `taskAssigneeLikeIgnoreCase(String assigneeLikeIgnoreCase)` Only select tasks which were last assigned to an assignee like the given value.
    `T` | `taskCandidateGroup(String candidateGroup)` Only select tasks for which users in the given group are candidates.
    `T` | `taskCandidateGroupIn(List<String> candidateGroups)` Only select tasks for which the 'candidateGroup' is one of the given groups.
    `T` | `taskCandidateUser(String candidateUser)` Only select tasks for which the given user is a candidate.
    `T` | `taskCategory(String category)` Only select tasks with the given category.
    `T` | `taskCreatedAfter(Date after)` Only select tasks that are created after the given date.
    `T` | `taskCreatedBefore(Date before)` Only select tasks that are created before the given date.
    `T` | `taskCreatedOn(Date createTime)` Only select tasks that are created on the given date.
    `T` | `taskDefinitionKey(String key)` Only select tasks with the given taskDefinitionKey.
    `T` | `taskDefinitionKeyLike(String keyLike)` Only select tasks with a taskDefinitionKey that match the given parameter.
    `T` | `taskDescription(String description)` Only select tasks with the given description.
    `T` | `taskDescriptionLike(String descriptionLike)` Only select tasks with a description matching the parameter .
    `T` | `taskDescriptionLikeIgnoreCase(String descriptionLike)` Only select tasks with a description matching the parameter .
    `T` | `taskDueAfter(Date dueDate)`
    `T` | `taskDueBefore(Date dueDate)`
    `T` | `taskDueDate(Date dueDate)`
    `T` | `taskId(String taskId)` Only select tasks with the given task id (in practice, there will be maximum one of this kind)
    `T` | `taskInvolvedUser(String involvedUser)` Only select tasks for which there exist an `IdentityLink` with the given user, including tasks which have been assigned to the given user (assignee) or owned by the given user (owner).
    `T` | `taskMaxPriority(Integer maxPriority)` Only select tasks with the given priority or lower.
    `T` | `taskMinPriority(Integer minPriority)` Only select tasks with the given priority or higher.
    `T` | `taskName(String name)` Only select tasks with the given name
    `T` | `taskNameIn(List<String> nameList)` Only select tasks with a name that is in the given list
    `T` | `taskNameInIgnoreCase(List<String> nameList)` Only select tasks with a name that is in the given list This method, unlike the `taskNameIn(List)` method will not take in account the upper/lower case: both the input parameters as the column value are lowercased when the query is executed.
    `T` | `taskNameLike(String nameLike)` Only select tasks with a name matching the parameter.
    `T` | `taskNameLikeIgnoreCase(String nameLike)` Only select tasks with a name matching the parameter.
    `T` | `taskOwner(String owner)` Only select tasks for which the given user is the owner.
    `T` | `taskOwnerLike(String ownerLike)` Only select tasks which were last assigned to an owner like the given value.
    `T` | `taskOwnerLikeIgnoreCase(String ownerLikeIgnoreCase)` Only select tasks which were last assigned to an owner like the given value.
    `T` | `taskPriority(Integer priority)` Only select tasks with the given priority.
    `T` | `taskTenantId(String tenantId)` Only select tasks that have the given tenant id.
    `T` | `taskTenantIdLike(String tenantIdLike)` Only select tasks with a tenant id like the given one.
    `T` | `taskVariableValueEquals(Object variableValue)` Only select tasks which have at least one local task variable with the given value.
    `T` | `taskVariableValueEquals(String variableName, Object variableValue)` Only select tasks which have a local task variable with the given name set to the given value.
    `T` | `taskVariableValueEqualsIgnoreCase(String name, String value)` Only select tasks which have a local string variable with the given value, case insensitive.
    `T` | `taskVariableValueGreaterThan(String name, Object value)` Only select tasks which have a local variable value greater than the passed value when they ended.
    `T` | `taskVariableValueGreaterThanOrEqual(String name, Object value)` Only select tasks which have a local variable value greater than or equal to the passed value when they ended.
    `T` | `taskVariableValueLessThan(String name, Object value)` Only select tasks which have a local variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    `T` | `taskVariableValueLessThanOrEqual(String name, Object value)` Only select tasks which have a local variable value less than or equal to the passed value when they ended.
    `T` | `taskVariableValueLike(String name, String value)` Only select tasks which have a local variable value like the given value when they ended.
    `T` | `taskVariableValueLikeIgnoreCase(String name, String value)` Only select tasks which have a local variable value like the given value (case insensitive) when they ended.
    `T` | `taskVariableValueNotEquals(String variableName, Object variableValue)` Only select tasks which have a local task variable with the given name, but with a different value than the passed value.
    `T` | `taskVariableValueNotEqualsIgnoreCase(String name, String value)` Only select tasks which have a local string variable with is not the given value, case insensitive.
    `T` | `taskWithoutTenantId()` Only select tasks that do not have a tenant id.
    `T` | `withLocalizationFallback()` Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.
    `T` | `withoutDueDate()` Deprecated.
    `T` | `withoutTaskDueDate()`

    - ### Methods inherited from interface org.activiti.engine.query.Query

      `asc, count, desc, list, listPage, singleResult`

- - ### Method Detail

    - #### taskId

          T taskId(String taskId)

      Only select tasks with the given task id (in practice, there will be maximum one of this kind)

    - #### taskName

          T taskName(String name)

      Only select tasks with the given name

    - #### taskNameIn

          T taskNameIn(List<String> nameList)

      Only select tasks with a name that is in the given list
      Throws:
        `ActivitiIllegalArgumentException` - When passed name list is empty or `null` or contains `null String`.

    - #### taskNameInIgnoreCase

          T taskNameInIgnoreCase(List<String> nameList)

      Only select tasks with a name that is in the given list This method, unlike the `taskNameIn(List)` method will not take in account the upper/lower case: both the input parameters as the column value are lowercased when the query is executed.
      Throws:
        `ActivitiIllegalArgumentException` - When passed name list is empty or `null` or contains `null String`.

    - #### taskNameLike

          T taskNameLike(String nameLike)

      Only select tasks with a name matching the parameter. The syntax is that of SQL: for example usage: nameLike(%activiti%)

    - #### taskNameLikeIgnoreCase

          T taskNameLikeIgnoreCase(String nameLike)

      Only select tasks with a name matching the parameter. The syntax is that of SQL: for example usage: nameLike(%activiti%) This method, unlike the `taskNameLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### taskDescription

          T taskDescription(String description)

      Only select tasks with the given description.

    - #### taskDescriptionLike

          T taskDescriptionLike(String descriptionLike)

      Only select tasks with a description matching the parameter . The syntax is that of SQL: for example usage: descriptionLike(%activiti%)

    - #### taskDescriptionLikeIgnoreCase

          T taskDescriptionLikeIgnoreCase(String descriptionLike)

      Only select tasks with a description matching the parameter . The syntax is that of SQL: for example usage: descriptionLike(%activiti%) This method, unlike the `taskDescriptionLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### taskPriority

          T taskPriority(Integer priority)

      Only select tasks with the given priority.

    - #### taskMinPriority

          T taskMinPriority(Integer minPriority)

      Only select tasks with the given priority or higher.

    - #### taskMaxPriority

          T taskMaxPriority(Integer maxPriority)

      Only select tasks with the given priority or lower.

    - #### taskAssignee

          T taskAssignee(String assignee)

      Only select tasks which are assigned to the given user.

    - #### taskAssigneeLike

          T taskAssigneeLike(String assigneeLike)

      Only select tasks which were last assigned to an assignee like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%.

    - #### taskAssigneeLikeIgnoreCase

          T taskAssigneeLikeIgnoreCase(String assigneeLikeIgnoreCase)

      Only select tasks which were last assigned to an assignee like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%. This method, unlike the `taskAssigneeLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### taskOwner

          T taskOwner(String owner)

      Only select tasks for which the given user is the owner.

    - #### taskOwnerLike

          T taskOwnerLike(String ownerLike)

      Only select tasks which were last assigned to an owner like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%.

    - #### taskOwnerLikeIgnoreCase

          T taskOwnerLikeIgnoreCase(String ownerLikeIgnoreCase)

      Only select tasks which were last assigned to an owner like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%. This method, unlike the `taskOwnerLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### taskCandidateUser

          T taskCandidateUser(String candidateUser)

      Only select tasks for which the given user is a candidate.

    - #### taskInvolvedUser

          T taskInvolvedUser(String involvedUser)

      Only select tasks for which there exist an `IdentityLink` with the given user, including tasks which have been assigned to the given user (assignee) or owned by the given user (owner).

    - #### taskCandidateGroup

          T taskCandidateGroup(String candidateGroup)

      Only select tasks for which users in the given group are candidates.

    - #### taskCandidateGroupIn

          T taskCandidateGroupIn(List<String> candidateGroups)

      Only select tasks for which the 'candidateGroup' is one of the given groups.
      Throws:
        `ActivitiIllegalArgumentException` - When query is executed and `taskCandidateGroup(String)` or `taskCandidateUser(String)` has been executed on the query instance. When passed group list is empty or `null`.

    - #### taskTenantId

          T taskTenantId(String tenantId)

      Only select tasks that have the given tenant id.

    - #### taskTenantIdLike

          T taskTenantIdLike(String tenantIdLike)

      Only select tasks with a tenant id like the given one.

    - #### taskWithoutTenantId

          T taskWithoutTenantId()

      Only select tasks that do not have a tenant id.

    - #### processInstanceId

          T processInstanceId(String processInstanceId)

      Only select tasks for the given process instance id.

    - #### processInstanceIdIn

          T processInstanceIdIn(List<String> processInstanceIds)

      Only select tasks for the given process ids.

    - #### processInstanceBusinessKey

          T processInstanceBusinessKey(String processInstanceBusinessKey)

      Only select tasks foe the given business key

    - #### processInstanceBusinessKeyLike

          T processInstanceBusinessKeyLike(String processInstanceBusinessKeyLike)

      Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%activiti%").

    - #### processInstanceBusinessKeyLikeIgnoreCase

          T processInstanceBusinessKeyLikeIgnoreCase(String processInstanceBusinessKeyLikeIgnoreCase)

      Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%activiti%"). This method, unlike the `processInstanceBusinessKeyLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### executionId

          T executionId(String executionId)

      Only select tasks for the given execution.

    - #### taskCreatedOn

          T taskCreatedOn(Date createTime)

      Only select tasks that are created on the given date.

    - #### taskCreatedBefore

          T taskCreatedBefore(Date before)

      Only select tasks that are created before the given date.

    - #### taskCreatedAfter

          T taskCreatedAfter(Date after)

      Only select tasks that are created after the given date.

    - #### taskCategory

          T taskCategory(String category)

      Only select tasks with the given category.

    - #### taskDefinitionKey

          T taskDefinitionKey(String key)

      Only select tasks with the given taskDefinitionKey. The task definition key is the id of the userTask: <userTask id="xxx" .../>

    - #### taskDefinitionKeyLike

          T taskDefinitionKeyLike(String keyLike)

      Only select tasks with a taskDefinitionKey that match the given parameter. The syntax is that of SQL: for example usage: taskDefinitionKeyLike("%activiti%"). The task definition key is the id of the userTask: <userTask id="xxx" .../>

    - #### dueDate

          T dueDate(Date dueDate)

      Deprecated.
      Only select tasks with the given due date.

    - #### taskDueDate

          T taskDueDate(Date dueDate)

    - #### dueBefore

          T dueBefore(Date dueDate)

      Deprecated.
      Only select tasks which have a due date before the given date.

    - #### taskDueBefore

          T taskDueBefore(Date dueDate)

    - #### dueAfter

          T dueAfter(Date dueDate)

      Deprecated.
      Only select tasks which have a due date after the given date.

    - #### taskDueAfter

          T taskDueAfter(Date dueDate)

    - #### withoutDueDate

          T withoutDueDate()

      Deprecated.
      Only select tasks with no due date.

    - #### withoutTaskDueDate

          T withoutTaskDueDate()

    - #### processDefinitionKey

          T processDefinitionKey(String processDefinitionKey)

      Only select tasks which are part of a process instance which has the given process definition key.

    - #### processDefinitionKeyLike

          T processDefinitionKeyLike(String processDefinitionKeyLike)

      Only select tasks which are part of a process instance which has a process definition key like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%.

    - #### processDefinitionKeyLikeIgnoreCase

          T processDefinitionKeyLikeIgnoreCase(String processDefinitionKeyLikeIgnoreCase)

      Only select tasks which are part of a process instance which has a process definition key like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%. This method, unlike the `processDefinitionKeyLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

    - #### processDefinitionKeyIn

          T processDefinitionKeyIn(List<String> processDefinitionKeys)

      Only select tasks that have a process definition for which the key is present in the given list

    - #### processDefinitionId

          T processDefinitionId(String processDefinitionId)

      Only select tasks which are part of a process instance which has the given process definition id.

    - #### processDefinitionName

          T processDefinitionName(String processDefinitionName)

      Only select tasks which are part of a process instance which has the given process definition name.

    - #### processDefinitionNameLike

          T processDefinitionNameLike(String processDefinitionNameLike)

      Only select tasks which are part of a process instance which has a process definition name like the given value. The syntax that should be used is the same as in SQL, eg. %activiti%.

    - #### processCategoryIn

          T processCategoryIn(List<String> processCategoryInList)

      Only select tasks which are part of a process instance whose definition belongs to the category which is present in the given list.
      Parameters:
        `processCategoryInList` -
      Throws:
        `ActivitiIllegalArgumentException` - When passed category list is empty or `null` or contains `null String`.

    - #### processCategoryNotIn

          T processCategoryNotIn(List<String> processCategoryNotInList)

      Only select tasks which are part of a process instance whose definition does not belong to the category which is present in the given list.
      Parameters:
        `processCategoryNotInList` -
      Throws:
        `ActivitiIllegalArgumentException` - When passed category list is empty or `null` or contains `null String`.

    - #### deploymentId

          T deploymentId(String deploymentId)

      Only select tasks which are part of a process instance which has the given deployment id.

    - #### deploymentIdIn

          T deploymentIdIn(List<String> deploymentIds)

      Only select tasks which are part of a process instance which has the given deployment id.

    - #### taskVariableValueEquals

          T taskVariableValueEquals(String variableName,
                                    Object variableValue)

      Only select tasks which have a local task variable with the given name set to the given value.

    - #### taskVariableValueEquals

          T taskVariableValueEquals(Object variableValue)

      Only select tasks which have at least one local task variable with the given value.

    - #### taskVariableValueEqualsIgnoreCase

          T taskVariableValueEqualsIgnoreCase(String name,
                                              String value)

      Only select tasks which have a local string variable with the given value, case insensitive.

      This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    - #### taskVariableValueNotEquals

          T taskVariableValueNotEquals(String variableName,
                                       Object variableValue)

      Only select tasks which have a local task variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

    - #### taskVariableValueNotEqualsIgnoreCase

          T taskVariableValueNotEqualsIgnoreCase(String name,
                                                 String value)

      Only select tasks which have a local string variable with is not the given value, case insensitive.

      This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    - #### taskVariableValueGreaterThan

          T taskVariableValueGreaterThan(String name,
                                         Object value)

      Only select tasks which have a local variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### taskVariableValueGreaterThanOrEqual

          T taskVariableValueGreaterThanOrEqual(String name,
                                                Object value)

      Only select tasks which have a local variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### taskVariableValueLessThan

          T taskVariableValueLessThan(String name,
                                      Object value)

      Only select tasks which have a local variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### taskVariableValueLessThanOrEqual

          T taskVariableValueLessThanOrEqual(String name,
                                             Object value)

      Only select tasks which have a local variable value less than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### taskVariableValueLike

          T taskVariableValueLike(String name,
                                  String value)

      Only select tasks which have a local variable value like the given value when they ended. This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### taskVariableValueLikeIgnoreCase

          T taskVariableValueLikeIgnoreCase(String name,
                                            String value)

      Only select tasks which have a local variable value like the given value (case insensitive) when they ended. This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### processVariableValueEquals

          T processVariableValueEquals(String variableName,
                                       Object variableValue)

      Only select tasks which are part of a process that has a variable with the given name set to the given value.

    - #### processVariableValueEquals

          T processVariableValueEquals(Object variableValue)

      Only select tasks which are part of a process that has at least one variable with the given value.

    - #### processVariableValueEqualsIgnoreCase

          T processVariableValueEqualsIgnoreCase(String name,
                                                 String value)

      Only select tasks which are part of a process that has a local string variable which is not the given value, case insensitive.

      This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    - #### processVariableValueNotEquals

          T processVariableValueNotEquals(String variableName,
                                          Object variableValue)

      Only select tasks which have a variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

    - #### processVariableValueNotEqualsIgnoreCase

          T processVariableValueNotEqualsIgnoreCase(String name,
                                                    String value)

      Only select tasks which are part of a process that has a string variable with the given value, case insensitive.

      This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    - #### processVariableValueGreaterThan

          T processVariableValueGreaterThan(String name,
                                            Object value)

      Only select tasks which have a global variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### processVariableValueGreaterThanOrEqual

          T processVariableValueGreaterThanOrEqual(String name,
                                                   Object value)

      Only select tasks which have a global variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### processVariableValueLessThan

          T processVariableValueLessThan(String name,
                                         Object value)

      Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### processVariableValueLessThanOrEqual

          T processVariableValueLessThanOrEqual(String name,
                                                Object value)

      Only select tasks which have a global variable value less than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### processVariableValueLike

          T processVariableValueLike(String name,
                                     String value)

      Only select tasks which have a global variable value like the given value when they ended. This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### processVariableValueLikeIgnoreCase

          T processVariableValueLikeIgnoreCase(String name,
                                               String value)

      Only select tasks which have a global variable value like the given value (case insensitive) when they ended. This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### includeTaskLocalVariables

          T includeTaskLocalVariables()

      Include local task variables in the task query result

    - #### includeProcessVariables

          T includeProcessVariables()

      Include global task variables in the task query result

    - #### limitTaskVariables

          T limitTaskVariables(Integer taskVariablesLimit)

      Limit task variables

    - #### locale

          T locale(String locale)

      Localize task name and description to specified locale.

    - #### withLocalizationFallback

          T withLocalizationFallback()

      Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

    - #### or

          T or()

      All query clauses called will be added to a single or-statement. This or-statement will be included with the other already existing clauses in the query, joined by an 'and'. Calling endOr() will add all clauses to the regular query again. Calling or() after endOr() has been called will result in an exception.

    - #### endOr

          T endOr()

    - #### orderByTaskId

          T orderByTaskId()

      Order by task id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskName

          T orderByTaskName()

      Order by task name (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskDescription

          T orderByTaskDescription()

      Order by description (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskPriority

          T orderByTaskPriority()

      Order by priority (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskAssignee

          T orderByTaskAssignee()

      Order by assignee (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskCreateTime

          T orderByTaskCreateTime()

      Order by the time on which the tasks were created (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessInstanceId

          T orderByProcessInstanceId()

      Order by process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByExecutionId

          T orderByExecutionId()

      Order by execution id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessDefinitionId

          T orderByProcessDefinitionId()

      Order by process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskDueDate

          T orderByTaskDueDate()

      Order by task due date (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskOwner

          T orderByTaskOwner()

      Order by task owner (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTaskDefinitionKey

          T orderByTaskDefinitionKey()

      Order by task definition key (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTenantId

          T orderByTenantId()

      Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByDueDateNullsFirst

          T orderByDueDateNullsFirst()

      Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`). If any of the tasks have null for the due date, these will be first in the result.

    - #### orderByDueDateNullsLast

          T orderByDueDateNullsLast()

      Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`). If any of the tasks have null for the due date, these will be last in the result.

Copyright © 2016 Alfresco. All rights reserved.